package bin;

import kernel.peripherals.Peripherals.Peripheral;
import kernel.peripherals.Side;
import lib.cli.TermHandle;
import lib.cli.CLIApp;

using tink.CoreApi;

class Redstone extends CLIApp {
	public function new() {}

	public function invoke(handle:TermHandle):Future<Bool> {
		var subcommand = handle.args[0];

		var side:Null<Side> = handle.args[1];
		if (side == null) {
			handle.writeLn("Invalid side");
			return Future.sync(false);
		}

		switch (subcommand) {
			case "on":
				Peripheral.instance.getRedstone(side).setOutput(true);
			case "off":
				Peripheral.instance.getRedstone(side).setOutput(false);
			case "get":
				var value = Peripheral.instance.getRedstone(side).getAnalogInput();
				handle.writeLn("Analog input: " + value);
			default:
				handle.writeLn("Invalid subcommand");
				return Future.sync(false);
		}

		return Future.sync(true);
	}
}
